create or alter procedure GET_REG_RECORDS_NEW (
    ID_REPORT integer,
    DIAGFILTER char(1),
    MINDIAG varchar(10),
    MAXDIAG varchar(10),
    FAMFILTER char(1),
    MINFAM varchar(50),
    MAXFAM varchar(50),
    D_ZAPOLFILTER char(1),
    MINZDATE date,
    MAXZDATE date,
    MINSUMM numeric(18,2),
    MAXSUMM numeric(18,2),
    LOCALFILTER char(1),
    FOREIGNFILTER char(1),
    POSCOUNTFILTER char(1),
    MINPOSCOUNT smallint,
    MAXPOSCOUNT smallint,
    HEALDAYSFILTER char(1),
    MINHEALDAYS integer,
    MAXHEALDAYS integer,
    RESPOSEHFILTER char(1),
    RESPOSEH char(2),
    COMPANYFILTER char(1),
    COMPANY varchar(60),
    DRFILTER char(1),
    MINDR date,
    MAXDR date,
    SNILSFILTER char(1),
    SNILS char(14),
    MESFILTER char(1),
    MINMES char(11),
    MAXMES char(11),
    VIDFILTER char(1),
    MINVID char(1),
    MAXVID char(1),
    VIBFILTER char(1),
    VI_B integer,
    SNFILTER char(1),
    V_SN char(25),
    NUBFILTER char(1),
    V_NUB char(10),
    INVFILTER char(1),
    V_INV char(1),
    CELFILTER char(1),
    V_CEL char(1),
    ONKOFILTER char(1),
    V_SL char(2))
returns (
    ID_STATTALON integer,
    NUB_K char(10),
    SS char(14),
    SN_POL char(25),
    FAM varchar(40),
    W char(1),
    DR date,
    D_ZA date,
    VID_O char(1),
    D_P_USL date,
    D_OS char(7),
    TERR char(4),
    SUMM numeric(18,2),
    D_ZAPOL date,
    POS_COUNT integer,
    HEAL_DAYS integer,
    RESULT_CODE char(2),
    RESULT_NAME varchar(50),
    DIAG_CODE char(7),
    COMPANY_CODE char(4),
    IM varchar(40),
    OT varchar(40),
    NER_PEN integer,
    DOP_DIS char(1),
    K_MES char(11),
    VI integer,
    S_OS integer,
    S_VIDEL integer,
    SN_INV char(1),
    GRE integer,
    SNDOK char(25),
    ADR varchar(100),
    MKD char(6),
    REP integer,
    CEL_P char(1),
    SL char(2))
as
declare variable ID_FYSMANUAL integer;
declare variable ID_SOPUT integer;
begin
    select id_fysmanual from report where id_report = :id_report into :id_fysmanual;

    for select id_stattalon, nub_k, ss, sn_pol, fam, im, ot, w, stattalon.dr, d_za, vid_o, d_p_usl,
                d_os, STATTALON.terr, summ, STATTALON.d_zapol, heal_days,
                stattalon.lgot, stattalon.disp_d, rez_ob, rez_poseh.name, nozolog.code,
                company.shcompany, k_mes , stattalon.vib, stattalon.s_osn, stattalon.videl,
                stattalon.sn_inv, stattalon.gr_e, stattalon.sn_dok,stattalon.adres,stattalon.mkod,
                stattalon.st_repeat, stattalon.cel_p, stattalon.sl
    from STATTALON, TERR, COMPANY, REZ_POSEH, NOZOLOG
    where STATTALON.terr = TERR.kod
    and STATTALON.company = COMPANY.shcompany
    and stattalon.rez_ob = rez_poseh.sh
    and stattalon.d_os = nozolog.code
    and id_report = :id_report
    and ((:famFilter = '-') or (STATTALON.fam between :minFam and :maxFam))
    and ((:d_zapolFilter = '-') or (STATTALON.d_zapol between :minZDate and :maxZDate))
    and ((:resPosehFilter = '-') or (STATTALON.rez_ob = :resPoseh))
    and ((:maxSumm = 0) or (STATTALON.summ between :minSumm and :maxSumm))
    and ((:localFilter = '-') or (STATTALON.terr = 1137))
    and ((:foreignFilter = '-') or (STATTALON.terr <> 1137))
    and ((:drfilter = '-') or (STATTALON.dr between :mindr and :maxdr))
    and ((:companyFilter = '-') or (company.company = :company))
    and ((:snilsFilter = '-') or (stattalon.ss = :snils))
    and ((:mesfilter = '-') or (STATTALON.k_mes between :minmes and :maxmes))
    and ((:vidfilter = '-') or (STATTALON.vid_o between :minvid and :maxvid))
    and ((:vibfilter = '-') or (stattalon.vib= :vi_b))
    and ((:snfilter = '-') or (stattalon.sn_pol= :v_sn))
    and ((:nubfilter = '-') or (stattalon.nub_k= :v_nub))
    and ((:invfilter = '-') or (stattalon.sn_inv = :v_inv))
    and ((:celfilter = '-') or (stattalon.cel_p = :v_cel))
    and ((:onkofilter = '-') or (stattalon.sl = :v_sl))
 /*   order by nub_k    */
   order by stattalon.fam, stattalon.im,  stattalon.ot, stattalon.dr
    into :id_stattalon, :nub_k, :ss, :sn_pol, :fam, :im, :ot, :w, :dr, :d_za, :vid_o, :d_p_usl,
            :d_os, :terr, :summ, :d_zapol, :heal_days, :ner_pen , :dop_dis,
            :result_code, :result_name,  :diag_code, :company_code, :k_mes, :vi, :s_os, :s_videl,
            :sn_inv, :gre, :sndok, :adr, :mkd, :rep, :cel_p, :sl do
    begin
        pos_count = 0;
        select count(*) from usl_od
            where usl_od.id_stattalon = :id_stattalon
            and usl_od.diag = :d_os
            and usl_od.paid = 1
            into :pos_count;

        if (((:diagFilter = '-') or (:d_os between :minDiag and :maxDiag))
            and ((:posCountFilter = '-') or (:pos_count between :minPosCount and :maxPosCount))
            and ((:healDaysFilter = '-') or (:heal_days between :minHealDays and :maxHealDays))) then
        begin
            suspend;
        end

        result_name = null;
        summ = null;
        for select soput.id_soput, soput.diag, soput.pos_count, nozolog.code, soput.heal_days, soput.k_mes
            from SOPUT, NOZOLOG
            where soput.id_stattalon = :id_stattalon
            and soput.diag = nozolog.code
            and ((:diagFilter = '-') or (:d_os between :minDiag and :maxDiag))
            and ((:posCountFilter = '-') or (soput.pos_count between :minPosCount and :maxPosCount))
            and ((:healDaysFilter = '-') or (soput.heal_days between :minHealDays and :maxHealDays))
            and ((:mesfilter = '-') or (soput.k_mes between :minmes and :maxmes))
            into :id_soput, :d_os, :pos_count, :diag_code, :heal_days, :k_mes do
        begin
            suspend;
        end
    end
end